]>
Commit | Line | Data |
---|---|---|
1 | #!/bin/sh -- # no runable script, just for vi | |
2 | ||
3 | EXIT_CODE=0 | |
4 | ||
5 | # we all like colorful messages | |
6 | if [ "$MSGCOLOR" != 'NO' ]; then | |
7 | if ! expr match "$(readlink -f /proc/$$/fd/1)" '/dev/pts/[0-9]\+' > /dev/null; then | |
8 | export MSGCOLOR='NO' | |
9 | fi | |
10 | fi | |
11 | ||
12 | ||
13 | if [ "$MSGCOLOR" != 'NO' ]; then | |
14 | CERROR="\033[1;31m" # red | |
15 | CWARNING="\033[1;33m" # yellow | |
16 | CMSG="\033[1;32m" # green | |
17 | CINFO="\033[1;96m" # light blue | |
18 | CDEBUG="\033[1;94m" # blue | |
19 | CNORMAL="\033[0;39m" # default system console color | |
20 | CDONE="\033[1;32m" # green | |
21 | CPASS="\033[1;32m" # green | |
22 | CFAIL="\033[1;31m" # red | |
23 | CCMD="\033[1;35m" # pink | |
24 | fi | |
25 | ||
26 | msgdie() { echo "${CERROR}E: $1${CNORMAL}" >&2; exit 1; } | |
27 | msgwarn() { echo "${CWARNING}W: $1${CNORMAL}" >&2; } | |
28 | msgmsg() { echo "${CMSG}$1${CNORMAL}"; } | |
29 | msginfo() { echo "${CINFO}I: $1${CNORMAL}"; } | |
30 | msgdebug() { echo "${CDEBUG}D: $1${CNORMAL}"; } | |
31 | msgdone() { echo "${CDONE}DONE${CNORMAL}"; } | |
32 | msgnwarn() { echo -n "${CWARNING}W: $1${CNORMAL}" >&2; } | |
33 | msgnmsg() { echo -n "${CMSG}$1${CNORMAL}"; } | |
34 | msgninfo() { echo -n "${CINFO}I: $1${CNORMAL}"; } | |
35 | msgndebug() { echo -n "${CDEBUG}D: $1${CNORMAL}"; } | |
36 | msgtest() { | |
37 | while [ -n "$1" ]; do | |
38 | echo -n "${CINFO}$1${CCMD} " | |
39 | echo -n "$(echo "$2" | sed -e 's/^aptc/apt-c/' -e 's/^aptg/apt-g/' -e 's/^aptf/apt-f/')${CINFO} " | |
40 | shift | |
41 | if [ -n "$1" ]; then shift; else break; fi | |
42 | done | |
43 | echo -n "…${CNORMAL} " | |
44 | } | |
45 | msgpass() { echo "${CPASS}PASS${CNORMAL}"; } | |
46 | msgskip() { echo "${CWARNING}SKIP${CNORMAL}" >&2; } | |
47 | msgfail() { | |
48 | if [ $# -gt 0 ]; then echo "${CFAIL}FAIL: $*${CNORMAL}" >&2; | |
49 | else echo "${CFAIL}FAIL${CNORMAL}" >&2; fi | |
50 | EXIT_CODE=$((EXIT_CODE+1)); | |
51 | } | |
52 | ||
53 | # enable / disable Debugging | |
54 | MSGLEVEL=${MSGLEVEL:-3} | |
55 | if [ $MSGLEVEL -le 0 ]; then | |
56 | msgdie() { true; } | |
57 | fi | |
58 | if [ $MSGLEVEL -le 1 ]; then | |
59 | msgwarn() { true; } | |
60 | msgnwarn() { true; } | |
61 | fi | |
62 | if [ $MSGLEVEL -le 2 ]; then | |
63 | msgmsg() { true; } | |
64 | msgnmsg() { true; } | |
65 | msgtest() { true; } | |
66 | msgpass() { echo -n " ${CPASS}P${CNORMAL}"; } | |
67 | msgskip() { echo -n " ${CWARNING}S${CNORMAL}" >&2; } | |
68 | if [ -n "$CFAIL" ]; then | |
69 | msgfail() { echo -n " ${CFAIL}FAIL${CNORMAL}" >&2; EXIT_CODE=$((EXIT_CODE+1)); } | |
70 | else | |
71 | msgfail() { echo -n " ###FAILED###" >&2; EXIT_CODE=$((EXIT_CODE+1)); } | |
72 | fi | |
73 | fi | |
74 | if [ $MSGLEVEL -le 3 ]; then | |
75 | msginfo() { true; } | |
76 | msgninfo() { true; } | |
77 | fi | |
78 | if [ $MSGLEVEL -le 4 ]; then | |
79 | msgdebug() { true; } | |
80 | msgndebug() { true; } | |
81 | fi | |
82 | msgdone() { | |
83 | if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] || | |
84 | [ "$1" = "info" -a $MSGLEVEL -le 3 ] || | |
85 | [ "$1" = "msg" -a $MSGLEVEL -le 2 ] || | |
86 | [ "$1" = "warn" -a $MSGLEVEL -le 1 ] || | |
87 | [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then | |
88 | true; | |
89 | else | |
90 | echo "${CDONE}DONE${CNORMAL}"; | |
91 | fi | |
92 | } | |
93 | ||
94 | runapt() { | |
95 | msgdebug "Executing: ${CCMD}$*${CDEBUG} " | |
96 | local CMD="${BUILDDIRECTORY}/$1" | |
97 | if [ "$1" = 'sh' ]; then CMD='sh'; fi | |
98 | shift | |
99 | if [ -f ./aptconfig.conf ]; then | |
100 | MALLOC_PERTURB_=21 MALLOC_CHECK_=2 APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $CMD "$@" | |
101 | elif [ -f ../aptconfig.conf ]; then | |
102 | MALLOC_PERTURB_=21 MALLOC_CHECK_=2 APT_CONFIG=../aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $CMD "$@" | |
103 | else | |
104 | MALLOC_PERTURB_=21 MALLOC_CHECK_=2 LD_LIBRARY_PATH=${BUILDDIRECTORY} $CMD "$@" | |
105 | fi | |
106 | } | |
107 | aptconfig() { runapt apt-config "$@"; } | |
108 | aptcache() { runapt apt-cache "$@"; } | |
109 | aptcdrom() { runapt apt-cdrom "$@"; } | |
110 | aptget() { runapt apt-get "$@"; } | |
111 | aptftparchive() { runapt apt-ftparchive "$@"; } | |
112 | aptkey() { runapt apt-key "$@"; } | |
113 | aptmark() { runapt apt-mark "$@"; } | |
114 | apt() { runapt apt "$@"; } | |
115 | apthelper() { | |
116 | LD_LIBRARY_PATH=${APTHELPERBINDIR} ${APTHELPERBINDIR}/apt-helper "$@"; | |
117 | } | |
118 | aptwebserver() { | |
119 | LD_LIBRARY_PATH=${APTWEBSERVERBINDIR} ${APTWEBSERVERBINDIR}/aptwebserver "$@"; | |
120 | } | |
121 | dpkg() { | |
122 | command dpkg --root=${TMPWORKINGDIRECTORY}/rootdir --force-not-root --force-bad-path --log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log "$@" | |
123 | } | |
124 | dpkgcheckbuilddeps() { | |
125 | command dpkg-checkbuilddeps --admindir=${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg "$@" | |
126 | } | |
127 | aptitude() { | |
128 | if [ -f ./aptconfig.conf ]; then | |
129 | APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} command aptitude "$@" | |
130 | elif [ -f ../aptconfig.conf ]; then | |
131 | APT_CONFIG=../aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} command aptitude "$@" | |
132 | else | |
133 | LD_LIBRARY_PATH=${BUILDDIRECTORY} command aptitude "$@" | |
134 | fi | |
135 | } | |
136 | gdb() { | |
137 | echo "gdb: run »$*«" | |
138 | APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} command gdb ${BUILDDIRECTORY}/$1 --args "$@" | |
139 | } | |
140 | http() { | |
141 | LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/methods/http | |
142 | } | |
143 | gpg() { | |
144 | # see apt-key for the whole trickery. Setup is done in setupenvironment | |
145 | command gpg --ignore-time-conflict --no-options --no-default-keyring \ | |
146 | --homedir "${TMPWORKINGDIRECTORY}/gnupghome" \ | |
147 | --no-auto-check-trustdb --trust-model always \ | |
148 | "$@" | |
149 | } | |
150 | ||
151 | exitwithstatus() { | |
152 | # error if we about to overflow, but ... | |
153 | # "255 failures ought to be enough for everybody" | |
154 | if [ $EXIT_CODE -gt 255 ]; then | |
155 | msgdie "Total failure count $EXIT_CODE too big" | |
156 | fi | |
157 | exit $((EXIT_CODE <= 255 ? EXIT_CODE : 255)); | |
158 | } | |
159 | ||
160 | shellsetedetector() { | |
161 | local exit_status=$? | |
162 | if [ "$exit_status" != '0' ]; then | |
163 | echo >&2 "${CERROR}E: Looks like the testcases ended prematurely with exitcode: ${exit_status}${CNORMAL}" | |
164 | if [ "$EXIT_CODE" = '0' ]; then | |
165 | EXIT_CODE="$exit_status" | |
166 | fi | |
167 | fi | |
168 | } | |
169 | ||
170 | addtrap() { | |
171 | if [ "$1" = 'prefix' ]; then | |
172 | CURRENTTRAP="$2 $CURRENTTRAP" | |
173 | else | |
174 | CURRENTTRAP="$CURRENTTRAP $1" | |
175 | fi | |
176 | trap "shellsetedetector; $CURRENTTRAP exitwithstatus;" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM | |
177 | } | |
178 | ||
179 | setupenvironment() { | |
180 | TMPWORKINGDIRECTORY=$(mktemp -d) | |
181 | TESTDIRECTORY=$(readlink -f $(dirname $0)) | |
182 | msgninfo "Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… " | |
183 | ||
184 | # allow overriding the default BUILDDIR location | |
185 | BUILDDIRECTORY=${APT_INTEGRATION_TESTS_BUILD_DIR:-"${TESTDIRECTORY}/../../build/bin"} | |
186 | METHODSDIR=${APT_INTEGRATION_TESTS_METHODS_DIR:-"${BUILDDIRECTORY}/methods"} | |
187 | APTHELPERBINDIR=${APT_INTEGRATION_TESTS_LIBEXEC_DIR:-"${BUILDDIRECTORY}"} | |
188 | APTWEBSERVERBINDIR=${APT_INTEGRATION_TESTS_WEBSERVER_BIN_DIR:-"${BUILDDIRECTORY}"} | |
189 | test -x "${BUILDDIRECTORY}/apt-get" || msgdie "You need to build tree first" | |
190 | # ----- | |
191 | ||
192 | addtrap "cd /; rm -rf $TMPWORKINGDIRECTORY;" | |
193 | cd $TMPWORKINGDIRECTORY | |
194 | mkdir rootdir aptarchive keys | |
195 | cd rootdir | |
196 | mkdir -p etc/apt/apt.conf.d etc/apt/sources.list.d etc/apt/trusted.gpg.d etc/apt/preferences.d | |
197 | mkdir -p var/cache var/lib/apt var/log tmp | |
198 | mkdir -p var/lib/dpkg/info var/lib/dpkg/updates var/lib/dpkg/triggers | |
199 | touch var/lib/dpkg/available | |
200 | mkdir -p usr/lib/apt | |
201 | ln -s ${METHODSDIR} usr/lib/apt/methods | |
202 | ln -s ${BUILDDIRECTORY}/../../debian/apt.conf.autoremove etc/apt/apt.conf.d/01autoremove | |
203 | cd .. | |
204 | local PACKAGESFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/') | |
205 | if [ -f "${TESTDIRECTORY}/${PACKAGESFILE}" ]; then | |
206 | cp "${TESTDIRECTORY}/${PACKAGESFILE}" aptarchive/Packages | |
207 | fi | |
208 | local SOURCESSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Sources-/' -e 's/^skip-/Sources-/') | |
209 | if [ -f "${TESTDIRECTORY}/${SOURCESSFILE}" ]; then | |
210 | cp "${TESTDIRECTORY}/${SOURCESSFILE}" aptarchive/Sources | |
211 | fi | |
212 | cp $(find $TESTDIRECTORY -name '*.pub' -o -name '*.sec') keys/ | |
213 | ln -s ${TMPWORKINGDIRECTORY}/keys/joesixpack.pub rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg | |
214 | echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf | |
215 | echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf | |
216 | echo "Debug::NoLocking \"true\";" >> aptconfig.conf | |
217 | echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf | |
218 | echo "Dir::Bin::Methods \"${METHODSDIR}\";" >> aptconfig.conf | |
219 | echo "Dir::Bin::dpkg \"fakeroot\";" >> aptconfig.conf | |
220 | echo "DPKG::options:: \"dpkg\";" >> aptconfig.conf | |
221 | echo "DPKG::options:: \"--root=${TMPWORKINGDIRECTORY}/rootdir\";" >> aptconfig.conf | |
222 | echo "DPKG::options:: \"--force-not-root\";" >> aptconfig.conf | |
223 | echo "DPKG::options:: \"--force-bad-path\";" >> aptconfig.conf | |
224 | if ! command dpkg --assert-multi-arch >/dev/null 2>&1; then | |
225 | echo "DPKG::options:: \"--force-architecture\";" >> aptconfig.conf # Added to test multiarch before dpkg is ready for it… | |
226 | fi | |
227 | echo "DPKG::options:: \"--log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log\";" >> aptconfig.conf | |
228 | echo 'quiet::NoUpdate "true";' >> aptconfig.conf | |
229 | echo "Acquire::https::CaInfo \"${TESTDIR}/apt.pem\";" > rootdir/etc/apt/apt.conf.d/99https | |
230 | echo "Apt::Cmd::Disable-Script-Warning \"1\";" > rootdir/etc/apt/apt.conf.d/apt-binary | |
231 | configcompression '.' 'gz' #'bz2' 'lzma' 'xz' | |
232 | ||
233 | # gpg needs a trustdb to function, but it can't be invalid (not even empty) | |
234 | # see also apt-key where this trickery comes from: | |
235 | local TRUSTDBDIR="${TMPWORKINGDIRECTORY}/gnupghome" | |
236 | mkdir "$TRUSTDBDIR" | |
237 | chmod 700 "$TRUSTDBDIR" | |
238 | # We also don't use a secret keyring, of course, but gpg panics and | |
239 | # implodes if there isn't one available - and writeable for imports | |
240 | local SECRETKEYRING="${TRUSTDBDIR}/secring.gpg" | |
241 | touch $SECRETKEYRING | |
242 | # now create the trustdb with an (empty) dummy keyring | |
243 | # newer gpg versions are fine without it, but play it safe for now | |
244 | gpg --quiet --check-trustdb --secret-keyring $SECRETKEYRING --keyring $SECRETKEYRING >/dev/null 2>&1 | |
245 | ||
246 | # cleanup the environment a bit | |
247 | export PATH="${PATH}:/usr/local/sbin:/usr/sbin:/sbin" | |
248 | export LC_ALL=C.UTF-8 | |
249 | unset LANGUAGE | |
250 | unset GREP_OPTIONS DEB_BUILD_PROFILES | |
251 | ||
252 | msgdone "info" | |
253 | } | |
254 | ||
255 | getarchitecture() { | |
256 | if [ "$1" = "native" -o -z "$1" ]; then | |
257 | eval `aptconfig shell ARCH APT::Architecture` | |
258 | if [ -n "$ARCH" ]; then | |
259 | echo $ARCH | |
260 | else | |
261 | dpkg --print-architecture | |
262 | fi | |
263 | else | |
264 | echo $1 | |
265 | fi | |
266 | } | |
267 | ||
268 | getarchitectures() { | |
269 | echo "$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')" | |
270 | } | |
271 | ||
272 | configarchitecture() { | |
273 | { | |
274 | echo "APT::Architecture \"$(getarchitecture $1)\";" | |
275 | while [ -n "$1" ]; do | |
276 | echo "APT::Architectures:: \"$(getarchitecture $1)\";" | |
277 | shift | |
278 | done | |
279 | } >rootdir/etc/apt/apt.conf.d/01multiarch.conf | |
280 | configdpkg | |
281 | } | |
282 | ||
283 | configdpkg() { | |
284 | if [ ! -e rootdir/var/lib/dpkg/status ]; then | |
285 | local STATUSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/') | |
286 | if [ -f "${TESTDIRECTORY}/${STATUSFILE}" ]; then | |
287 | cp "${TESTDIRECTORY}/${STATUSFILE}" rootdir/var/lib/dpkg/status | |
288 | else | |
289 | echo -n > rootdir/var/lib/dpkg/status | |
290 | fi | |
291 | fi | |
292 | rm -f rootdir/etc/apt/apt.conf.d/00foreigndpkg | |
293 | if command dpkg --assert-multi-arch >/dev/null 2>&1 ; then | |
294 | local ARCHS="$(getarchitectures)" | |
295 | if echo "$ARCHS" | grep -E -q '[^ ]+ [^ ]+'; then | |
296 | DPKGARCH="$(dpkg --print-architecture)" | |
297 | for ARCH in ${ARCHS}; do | |
298 | if [ "${ARCH}" != "${DPKGARCH}" ]; then | |
299 | if ! dpkg --add-architecture ${ARCH} >/dev/null 2>&1; then | |
300 | # old-style used e.g. in Ubuntu-P – and as it seems travis | |
301 | echo "DPKG::options:: \"--foreign-architecture\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg | |
302 | echo "DPKG::options:: \"${ARCH}\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg | |
303 | fi | |
304 | fi | |
305 | done | |
306 | if [ "0" = "$(dpkg -l dpkg 2> /dev/null | grep '^i' | wc -l)" ]; then | |
307 | # dpkg doesn't really check the version as long as it is fully installed, | |
308 | # but just to be sure we choose one above the required version | |
309 | insertinstalledpackage 'dpkg' "all" '1.16.2+fake' | |
310 | fi | |
311 | fi | |
312 | fi | |
313 | } | |
314 | ||
315 | configcompression() { | |
316 | while [ -n "$1" ]; do | |
317 | case "$1" in | |
318 | '.') echo ".\t.\tcat";; | |
319 | 'gz') echo "gzip\tgz\tgzip";; | |
320 | 'bz2') echo "bzip2\tbz2\tbzip2";; | |
321 | 'lzma') echo "lzma\tlzma\txz --format=lzma";; | |
322 | 'xz') echo "xz\txz\txz";; | |
323 | *) echo "$1\t$1\t$1";; | |
324 | esac | |
325 | shift | |
326 | done > ${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf | |
327 | } | |
328 | ||
329 | setupsimplenativepackage() { | |
330 | local NAME="$1" | |
331 | local ARCH="$2" | |
332 | local VERSION="$3" | |
333 | local RELEASE="${4:-unstable}" | |
334 | local DEPENDENCIES="$5" | |
335 | local DESCRIPTION="${6:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE} | |
336 | If you find such a package installed on your system, | |
337 | something went horribly wrong! They are autogenerated | |
338 | und used only by testcases and surf no other propose…"}" | |
339 | ||
340 | local SECTION="${7:-others}" | |
341 | local DISTSECTION | |
342 | if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then | |
343 | DISTSECTION="main" | |
344 | else | |
345 | DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)" | |
346 | fi | |
347 | local BUILDDIR=incoming/${NAME}-${VERSION} | |
348 | mkdir -p ${BUILDDIR}/debian/source | |
349 | cd ${BUILDDIR} | |
350 | echo "* most suckless software product ever" > FEATURES | |
351 | test -e debian/copyright || echo "Copyleft by Joe Sixpack $(date +%Y)" > debian/copyright | |
352 | test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency=low | |
353 | ||
354 | * Initial release | |
355 | ||
356 | -- Joe Sixpack <joe@example.org> $(date -R)" > debian/changelog | |
357 | test -e debian/control || echo "Source: $NAME | |
358 | Section: $SECTION | |
359 | Priority: optional | |
360 | Maintainer: Joe Sixpack <joe@example.org> | |
361 | Build-Depends: debhelper (>= 7) | |
362 | Standards-Version: 3.9.1 | |
363 | ||
364 | Package: $NAME" > debian/control | |
365 | if [ "$ARCH" = 'all' ]; then | |
366 | echo "Architecture: all" >> debian/control | |
367 | else | |
368 | echo "Architecture: any" >> debian/control | |
369 | fi | |
370 | test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control | |
371 | echo "Description: $DESCRIPTION" >> debian/control | |
372 | ||
373 | test -e debian/compat || echo "7" > debian/compat | |
374 | test -e debian/source/format || echo "3.0 (native)" > debian/source/format | |
375 | test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules | |
376 | cd - > /dev/null | |
377 | } | |
378 | ||
379 | buildsimplenativepackage() { | |
380 | local NAME="$1" | |
381 | local ARCH="$2" | |
382 | local VERSION="$3" | |
383 | local RELEASE="${4:-unstable}" | |
384 | local DEPENDENCIES="$5" | |
385 | local DESCRIPTION="${6:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE} | |
386 | If you find such a package installed on your system, | |
387 | something went horribly wrong! They are autogenerated | |
388 | und used only by testcases and surf no other propose…"}" | |
389 | ||
390 | local SECTION="${7:-others}" | |
391 | local PRIORITY="${8:-optional}" | |
392 | local FILE_TREE="$9" | |
393 | local COMPRESS_TYPE="${10:-gzip}" | |
394 | local DISTSECTION | |
395 | if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then | |
396 | DISTSECTION="main" | |
397 | else | |
398 | DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)" | |
399 | fi | |
400 | local BUILDDIR=${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION} | |
401 | ||
402 | msgninfo "Build package ${NAME} in ${VERSION} for ${RELEASE} in ${DISTSECTION}… " | |
403 | mkdir -p $BUILDDIR/debian/source | |
404 | echo "* most suckless software product ever" > ${BUILDDIR}/FEATURES | |
405 | echo "#!/bin/sh | |
406 | echo '$NAME says \"Hello!\"'" > ${BUILDDIR}/${NAME} | |
407 | ||
408 | echo "Copyleft by Joe Sixpack $(date +%Y)" > ${BUILDDIR}/debian/copyright | |
409 | echo "$NAME ($VERSION) $RELEASE; urgency=low | |
410 | ||
411 | * Initial release | |
412 | ||
413 | -- Joe Sixpack <joe@example.org> $(date -R)" > ${BUILDDIR}/debian/changelog | |
414 | echo "Source: $NAME | |
415 | Section: $SECTION | |
416 | Priority: $PRIORITY | |
417 | Maintainer: Joe Sixpack <joe@example.org> | |
418 | Standards-Version: 3.9.3" > ${BUILDDIR}/debian/control | |
419 | local BUILDDEPS="$(echo "$DEPENDENCIES" | grep '^Build-')" | |
420 | test -z "$BUILDDEPS" || echo "$BUILDDEPS" >> ${BUILDDIR}/debian/control | |
421 | echo " | |
422 | Package: $NAME" >> ${BUILDDIR}/debian/control | |
423 | ||
424 | if [ "$ARCH" = 'all' ]; then | |
425 | echo "Architecture: all" >> ${BUILDDIR}/debian/control | |
426 | else | |
427 | echo "Architecture: any" >> ${BUILDDIR}/debian/control | |
428 | fi | |
429 | local DEPS="$(echo "$DEPENDENCIES" | grep -v '^Build-')" | |
430 | test -z "$DEPS" || echo "$DEPS" >> ${BUILDDIR}/debian/control | |
431 | echo "Description: $DESCRIPTION" >> ${BUILDDIR}/debian/control | |
432 | ||
433 | echo '3.0 (native)' > ${BUILDDIR}/debian/source/format | |
434 | (cd ${BUILDDIR}/..; dpkg-source -b ${NAME}-${VERSION} 2>&1) | sed -n 's#^dpkg-source: info: building [^ ]\+ in ##p' \ | |
435 | | while read SRC; do | |
436 | echo "pool/${SRC}" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.srclist | |
437 | # if expr match "${SRC}" '.*\.dsc' >/dev/null 2>&1; then | |
438 | # gpg --yes --secret-keyring ./keys/joesixpack.sec \ | |
439 | # --keyring ./keys/joesixpack.pub --default-key 'Joe Sixpack' \ | |
440 | # --clearsign -o "${BUILDDIR}/../${SRC}.sign" "${BUILDDIR}/../$SRC" | |
441 | # mv "${BUILDDIR}/../${SRC}.sign" "${BUILDDIR}/../$SRC" | |
442 | # fi | |
443 | done | |
444 | ||
445 | for arch in $(echo "$ARCH" | sed -e 's#,#\n#g' | sed -e "s#^native\$#$(getarchitecture 'native')#"); do | |
446 | rm -rf ${BUILDDIR}/debian/tmp | |
447 | mkdir -p ${BUILDDIR}/debian/tmp/DEBIAN ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME} ${BUILDDIR}/debian/tmp/usr/bin | |
448 | cp ${BUILDDIR}/debian/copyright ${BUILDDIR}/debian/changelog ${BUILDDIR}/FEATURES ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME} | |
449 | cp ${BUILDDIR}/${NAME} ${BUILDDIR}/debian/tmp/usr/bin/${NAME}-${arch} | |
450 | if [ -n "$FILE_TREE" ]; then | |
451 | cp -ar "$FILE_TREE" ${BUILDDIR}/debian/tmp | |
452 | fi | |
453 | ||
454 | (cd ${BUILDDIR}; dpkg-gencontrol -DArchitecture=$arch) | |
455 | (cd ${BUILDDIR}/debian/tmp; md5sum $(find usr/ -type f) > DEBIAN/md5sums) | |
456 | local LOG="${BUILDDIR}/../${NAME}_${VERSION}_${arch}.dpkg-deb.log" | |
457 | # ensure the right permissions as dpkg-deb ensists | |
458 | chmod 755 ${BUILDDIR}/debian/tmp/DEBIAN | |
459 | if ! dpkg-deb -Z${COMPRESS_TYPE} --build ${BUILDDIR}/debian/tmp ${BUILDDIR}/.. >$LOG 2>&1; then | |
460 | cat $LOG | |
461 | false | |
462 | fi | |
463 | rm $LOG | |
464 | echo "pool/${NAME}_${VERSION}_${arch}.deb" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.pkglist | |
465 | done | |
466 | ||
467 | mkdir -p ${BUILDDIR}/../${NAME}_${VERSION} | |
468 | cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}/ | |
469 | cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}.changelog | |
470 | rm -rf "${BUILDDIR}" | |
471 | msgdone "info" | |
472 | } | |
473 | ||
474 | buildpackage() { | |
475 | local BUILDDIR=$1 | |
476 | local RELEASE=$2 | |
477 | local SECTION=$3 | |
478 | local ARCH=$(getarchitecture $4) | |
479 | local PKGNAME="$(echo "$BUILDDIR" | grep -o '[^/]*$')" | |
480 | local BUILDLOG="$(readlink -f "${BUILDDIR}/../${PKGNAME}_${RELEASE}_${SECTION}.dpkg-bp.log")" | |
481 | msgninfo "Build package ${PKGNAME} for ${RELEASE} in ${SECTION}… " | |
482 | cd $BUILDDIR | |
483 | if [ "$ARCH" = "all" ]; then | |
484 | ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)" | |
485 | fi | |
486 | if ! dpkg-buildpackage -uc -us -a$ARCH >$BUILDLOG 2>&1 ; then | |
487 | cat $BUILDLOG | |
488 | false | |
489 | fi | |
490 | local PKGS="$(grep '^dpkg-deb: building package' $BUILDLOG | cut -d'/' -f 2 | sed -e "s#'\.##")" | |
491 | local SRCS="$(grep '^dpkg-source: info: building' $BUILDLOG | grep -o '[a-z0-9._+~-]*$')" | |
492 | cd - > /dev/null | |
493 | for PKG in $PKGS; do | |
494 | echo "pool/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist | |
495 | done | |
496 | for SRC in $SRCS; do | |
497 | echo "pool/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist | |
498 | done | |
499 | msgdone "info" | |
500 | } | |
501 | ||
502 | buildaptarchive() { | |
503 | if [ -d incoming ]; then | |
504 | buildaptarchivefromincoming "$@" | |
505 | else | |
506 | buildaptarchivefromfiles "$@" | |
507 | fi | |
508 | } | |
509 | ||
510 | createaptftparchiveconfig() { | |
511 | local COMPRESSORS="$(cut -d' ' -f 1 ${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf | tr '\n' ' ')" | |
512 | COMPRESSORS="${COMPRESSORS%* }" | |
513 | local ARCHS="$(find pool/ -name '*.deb' | grep -oE '_[a-z0-9-]+\.deb$' | sort | uniq | sed -e '/^_all.deb$/ d' -e 's#^_\([a-z0-9-]*\)\.deb$#\1#' | tr '\n' ' ')" | |
514 | if [ -z "$ARCHS" ]; then | |
515 | # the pool is empty, so we will operate on faked packages - let us use the configured archs | |
516 | ARCHS="$(getarchitectures)" | |
517 | fi | |
518 | echo -n 'Dir { | |
519 | ArchiveDir "' >> ftparchive.conf | |
520 | echo -n $(readlink -f .) >> ftparchive.conf | |
521 | echo -n '"; | |
522 | CacheDir "' >> ftparchive.conf | |
523 | echo -n $(readlink -f ..) >> ftparchive.conf | |
524 | echo -n '"; | |
525 | FileListDir "' >> ftparchive.conf | |
526 | echo -n $(readlink -f pool/) >> ftparchive.conf | |
527 | echo -n '"; | |
528 | }; | |
529 | Default { | |
530 | Packages::Compress "'"$COMPRESSORS"'"; | |
531 | Sources::Compress "'"$COMPRESSORS"'"; | |
532 | Contents::Compress "'"$COMPRESSORS"'"; | |
533 | Translation::Compress "'"$COMPRESSORS"'"; | |
534 | LongDescription "false"; | |
535 | }; | |
536 | TreeDefault { | |
537 | Directory "pool/"; | |
538 | SrcDirectory "pool/"; | |
539 | }; | |
540 | APT { | |
541 | FTPArchive { | |
542 | Release { | |
543 | Origin "joesixpack"; | |
544 | Label "apttestcases"; | |
545 | Suite "unstable"; | |
546 | Description "repository with dummy packages"; | |
547 | Architectures "' >> ftparchive.conf | |
548 | echo -n "$ARCHS" >> ftparchive.conf | |
549 | echo 'source"; | |
550 | }; | |
551 | }; | |
552 | };' >> ftparchive.conf | |
553 | for DIST in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do | |
554 | echo -n 'tree "dists/' >> ftparchive.conf | |
555 | echo -n "$DIST" >> ftparchive.conf | |
556 | echo -n '" { | |
557 | Architectures "' >> ftparchive.conf | |
558 | echo -n "$ARCHS" >> ftparchive.conf | |
559 | echo -n 'source"; | |
560 | FileList "' >> ftparchive.conf | |
561 | echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf | |
562 | echo -n '"; | |
563 | SourceFileList "' >> ftparchive.conf | |
564 | echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf | |
565 | echo -n '"; | |
566 | Sections "' >> ftparchive.conf | |
567 | echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf | |
568 | echo '"; | |
569 | };' >> ftparchive.conf | |
570 | done | |
571 | } | |
572 | ||
573 | buildaptftparchivedirectorystructure() { | |
574 | local DISTS="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')" | |
575 | for DIST in $DISTS; do | |
576 | local SECTIONS="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)" | |
577 | for SECTION in $SECTIONS; do | |
578 | local ARCHS="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')" | |
579 | for ARCH in $ARCHS; do | |
580 | mkdir -p dists/${DIST}/${SECTION}/binary-${ARCH} | |
581 | done | |
582 | mkdir -p dists/${DIST}/${SECTION}/source | |
583 | mkdir -p dists/${DIST}/${SECTION}/i18n | |
584 | done | |
585 | done | |
586 | } | |
587 | ||
588 | insertpackage() { | |
589 | local RELEASE="$1" | |
590 | local NAME="$2" | |
591 | local ARCH="$3" | |
592 | local VERSION="$4" | |
593 | local DEPENDENCIES="$5" | |
594 | local PRIORITY="${6:-optional}" | |
595 | local DESCRIPTION="${7:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE} | |
596 | If you find such a package installed on your system, | |
597 | something went horribly wrong! They are autogenerated | |
598 | und used only by testcases and surf no other propose…"}" | |
599 | local ARCHS="" | |
600 | for arch in $(echo "$ARCH" | sed -e 's#,#\n#g' | sed -e "s#^native\$#$(getarchitecture 'native')#"); do | |
601 | if [ "$arch" = 'all' -o "$arch" = 'none' ]; then | |
602 | ARCHS="$(getarchitectures)" | |
603 | else | |
604 | ARCHS="$arch" | |
605 | fi | |
606 | for BUILDARCH in $ARCHS; do | |
607 | local PPATH="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}" | |
608 | mkdir -p $PPATH aptarchive/dists/${RELEASE}/main/source | |
609 | touch aptarchive/dists/${RELEASE}/main/source/Sources | |
610 | local FILE="${PPATH}/Packages" | |
611 | echo "Package: $NAME | |
612 | Priority: $PRIORITY | |
613 | Section: other | |
614 | Installed-Size: 42 | |
615 | Maintainer: Joe Sixpack <joe@example.org>" >> $FILE | |
616 | test "$arch" = 'none' || echo "Architecture: $arch" >> $FILE | |
617 | echo "Version: $VERSION | |
618 | Filename: pool/main/${NAME}/${NAME}_${VERSION}_${arch}.deb" >> $FILE | |
619 | test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE | |
620 | echo "Description: $DESCRIPTION" >> $FILE | |
621 | echo >> $FILE | |
622 | done | |
623 | done | |
624 | } | |
625 | ||
626 | insertsource() { | |
627 | local RELEASE="$1" | |
628 | local NAME="$2" | |
629 | local ARCH="$3" | |
630 | local VERSION="$4" | |
631 | local DEPENDENCIES="$5" | |
632 | local ARCHS="" | |
633 | local SPATH="aptarchive/dists/${RELEASE}/main/source" | |
634 | mkdir -p $SPATH | |
635 | local FILE="${SPATH}/Sources" | |
636 | echo "Package: $NAME | |
637 | Binary: $NAME | |
638 | Version: $VERSION | |
639 | Maintainer: Joe Sixpack <joe@example.org> | |
640 | Architecture: $ARCH" >> $FILE | |
641 | test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE | |
642 | echo "Files: | |
643 | d41d8cd98f00b204e9800998ecf8427e 0 ${NAME}_${VERSION}.dsc | |
644 | d41d8cd98f00b204e9800998ecf8427e 0 ${NAME}_${VERSION}.tar.gz | |
645 | " >> $FILE | |
646 | } | |
647 | ||
648 | insertinstalledpackage() { | |
649 | local NAME="$1" | |
650 | local ARCH="$2" | |
651 | local VERSION="$3" | |
652 | local DEPENDENCIES="$4" | |
653 | local PRIORITY="${5:-optional}" | |
654 | local STATUS="${6:-install ok installed}" | |
655 | local DESCRIPTION="${7:-"an autogenerated dummy ${NAME}=${VERSION}/installed | |
656 | If you find such a package installed on your system, | |
657 | something went horribly wrong! They are autogenerated | |
658 | und used only by testcases and surf no other propose…"}" | |
659 | ||
660 | local FILE='rootdir/var/lib/dpkg/status' | |
661 | local INFO='rootdir/var/lib/dpkg/info' | |
662 | for arch in $(echo "$ARCH" | sed -e 's#,#\n#g' | sed -e "s#^native\$#$(getarchitecture 'native')#"); do | |
663 | echo "Package: $NAME | |
664 | Status: $STATUS | |
665 | Priority: $PRIORITY | |
666 | Section: other | |
667 | Installed-Size: 42 | |
668 | Maintainer: Joe Sixpack <joe@example.org> | |
669 | Version: $VERSION" >> $FILE | |
670 | test "$arch" = 'none' || echo "Architecture: $arch" >> $FILE | |
671 | test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE | |
672 | echo "Description: $DESCRIPTION" >> $FILE | |
673 | echo >> $FILE | |
674 | if [ "$(dpkg-query -W --showformat='${Multi-Arch}')" = 'same' ]; then | |
675 | echo -n > ${INFO}/${NAME}:${arch}.list | |
676 | else | |
677 | echo -n > ${INFO}/${NAME}.list | |
678 | fi | |
679 | done | |
680 | } | |
681 | ||
682 | ||
683 | buildaptarchivefromincoming() { | |
684 | msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…" | |
685 | cd aptarchive | |
686 | [ -e pool ] || ln -s ../incoming pool | |
687 | [ -e ftparchive.conf ] || createaptftparchiveconfig | |
688 | [ -e dists ] || buildaptftparchivedirectorystructure | |
689 | msgninfo "\tGenerate Packages, Sources and Contents files… " | |
690 | aptftparchive -qq generate ftparchive.conf | |
691 | cd - > /dev/null | |
692 | msgdone "info" | |
693 | generatereleasefiles | |
694 | } | |
695 | ||
696 | buildaptarchivefromfiles() { | |
697 | msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…" | |
698 | find aptarchive -name 'Packages' -o -name 'Sources' | while read line; do | |
699 | msgninfo "\t${line} file… " | |
700 | compressfile "$line" "$1" | |
701 | msgdone "info" | |
702 | done | |
703 | generatereleasefiles "$@" | |
704 | } | |
705 | ||
706 | compressfile() { | |
707 | cat ${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf | while read compressor extension command; do | |
708 | if [ "$compressor" = '.' ]; then | |
709 | if [ -n "$2" ]; then | |
710 | touch -d "$2" "$1" | |
711 | fi | |
712 | continue | |
713 | fi | |
714 | cat "$1" | $command > "${1}.${extension}" | |
715 | if [ -n "$2" ]; then | |
716 | touch -d "$2" "${1}.${extension}" | |
717 | fi | |
718 | done | |
719 | } | |
720 | ||
721 | # can be overridden by testcases for their pleasure | |
722 | getcodenamefromsuite() { | |
723 | case "$1" in | |
724 | unstable) echo 'sid';; | |
725 | *) echo -n "$1";; | |
726 | esac | |
727 | } | |
728 | getreleaseversionfromsuite() { true; } | |
729 | getlabelfromsuite() { true; } | |
730 | ||
731 | generatereleasefiles() { | |
732 | # $1 is the Date header and $2 is the ValidUntil header to be set | |
733 | # both should be given in notation date/touch can understand | |
734 | msgninfo "\tGenerate Release files… " | |
735 | if [ -e aptarchive/dists ]; then | |
736 | for dir in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do | |
737 | local SUITE="$(echo "$dir" | cut -d'/' -f 4)" | |
738 | local CODENAME="$(getcodenamefromsuite $SUITE)" | |
739 | local VERSION="$(getreleaseversionfromsuite $SUITE)" | |
740 | local LABEL="$(getlabelfromsuite $SUITE)" | |
741 | if [ -n "$VERSION" ]; then | |
742 | VERSION="-o APT::FTPArchive::Release::Version=${VERSION}" | |
743 | fi | |
744 | if [ -n "$LABEL" ]; then | |
745 | LABEL="-o APT::FTPArchive::Release::Label=${LABEL}" | |
746 | fi | |
747 | aptftparchive -qq release $dir \ | |
748 | -o APT::FTPArchive::Release::Suite="${SUITE}" \ | |
749 | -o APT::FTPArchive::Release::Codename="${CODENAME}" \ | |
750 | ${LABEL} \ | |
751 | ${VERSION} \ | |
752 | | sed -e '/0 Release$/ d' > $dir/Release # remove the self reference | |
753 | if [ "$SUITE" = "experimental" -o "$SUITE" = "experimental2" ]; then | |
754 | sed -i '/^Date: / a\ | |
755 | NotAutomatic: yes' $dir/Release | |
756 | fi | |
757 | if [ -n "$1" -a "$1" != "now" ]; then | |
758 | sed -i "s/^Date: .*$/Date: $(date -d "$1" '+%a, %d %b %Y %H:%M:%S %Z')/" $dir/Release | |
759 | fi | |
760 | if [ -n "$2" ]; then | |
761 | sed -i "/^Date: / a\ | |
762 | Valid-Until: $(date -d "$2" '+%a, %d %b %Y %H:%M:%S %Z')" $dir/Release | |
763 | fi | |
764 | done | |
765 | else | |
766 | aptftparchive -qq release ./aptarchive | sed -e '/0 Release$/ d' > aptarchive/Release # remove the self reference | |
767 | fi | |
768 | if [ -n "$1" -a "$1" != "now" ]; then | |
769 | for release in $(find ./aptarchive -name 'Release'); do | |
770 | touch -d "$1" $release | |
771 | done | |
772 | fi | |
773 | msgdone "info" | |
774 | } | |
775 | ||
776 | setupdistsaptarchive() { | |
777 | local APTARCHIVE=$(readlink -f ./aptarchive) | |
778 | rm -f root/etc/apt/sources.list.d/apt-test-*-deb.list | |
779 | rm -f root/etc/apt/sources.list.d/apt-test-*-deb-src.list | |
780 | for DISTS in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do | |
781 | SECTIONS=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ') | |
782 | msgninfo "\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… " | |
783 | echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb.list | |
784 | echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb-src.list | |
785 | msgdone "info" | |
786 | done | |
787 | } | |
788 | ||
789 | setupflataptarchive() { | |
790 | local APTARCHIVE=$(readlink -f ./aptarchive) | |
791 | if [ -f ${APTARCHIVE}/Packages ]; then | |
792 | msgninfo "\tadd deb sources.list line… " | |
793 | echo "deb file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list | |
794 | msgdone "info" | |
795 | else | |
796 | rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list | |
797 | fi | |
798 | if [ -f ${APTARCHIVE}/Sources ]; then | |
799 | msgninfo "\tadd deb-src sources.list line… " | |
800 | echo "deb-src file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list | |
801 | msgdone "info" | |
802 | else | |
803 | rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list | |
804 | fi | |
805 | } | |
806 | ||
807 | setupaptarchive() { | |
808 | buildaptarchive | |
809 | if [ -e aptarchive/dists ]; then | |
810 | setupdistsaptarchive | |
811 | else | |
812 | setupflataptarchive | |
813 | fi | |
814 | signreleasefiles | |
815 | if [ "$1" != '--no-update' ]; then | |
816 | msgninfo "\tSync APT's cache with the archive… " | |
817 | aptget update -qq | |
818 | msgdone "info" | |
819 | fi | |
820 | } | |
821 | ||
822 | signreleasefiles() { | |
823 | local SIGNER="${1:-Joe Sixpack}" | |
824 | local GPG="gpg --batch --yes" | |
825 | msgninfo "\tSign archive with $SIGNER key… " | |
826 | local REXKEY='keys/rexexpired' | |
827 | local SECEXPIREBAK="${REXKEY}.sec.bak" | |
828 | local PUBEXPIREBAK="${REXKEY}.pub.bak" | |
829 | if [ "${SIGNER}" = 'Rex Expired' ]; then | |
830 | # the key is expired, so gpg doesn't allow to sign with and the --faked-system-time | |
831 | # option doesn't exist anymore (and using faketime would add a new obscure dependency) | |
832 | # therefore we 'temporary' make the key not expired and restore a backup after signing | |
833 | cp ${REXKEY}.sec $SECEXPIREBAK | |
834 | cp ${REXKEY}.pub $PUBEXPIREBAK | |
835 | local SECUNEXPIRED="${REXKEY}.sec.unexpired" | |
836 | local PUBUNEXPIRED="${REXKEY}.pub.unexpired" | |
837 | if [ -f "$SECUNEXPIRED" ] && [ -f "$PUBUNEXPIRED" ]; then | |
838 | cp $SECUNEXPIRED ${REXKEY}.sec | |
839 | cp $PUBUNEXPIRED ${REXKEY}.pub | |
840 | else | |
841 | printf "expire\n1w\nsave\n" | $GPG --keyring ${REXKEY}.pub --secret-keyring ${REXKEY}.sec --command-fd 0 --edit-key "${SIGNER}" >/dev/null 2>&1 || true | |
842 | cp ${REXKEY}.sec $SECUNEXPIRED | |
843 | cp ${REXKEY}.pub $PUBUNEXPIRED | |
844 | fi | |
845 | fi | |
846 | for KEY in $(find keys/ -name '*.sec'); do | |
847 | GPG="$GPG --secret-keyring $KEY" | |
848 | done | |
849 | for KEY in $(find keys/ -name '*.pub'); do | |
850 | GPG="$GPG --keyring $KEY" | |
851 | done | |
852 | for RELEASE in $(find aptarchive/ -name Release); do | |
853 | $GPG --default-key "$SIGNER" --armor --detach-sign --sign --output ${RELEASE}.gpg ${RELEASE} | |
854 | local INRELEASE="$(echo "${RELEASE}" | sed 's#/Release$#/InRelease#')" | |
855 | $GPG --default-key "$SIGNER" --clearsign --output $INRELEASE $RELEASE | |
856 | # we might have set a specific date for the Release file, so copy it | |
857 | touch -d "$(stat --format "%y" ${RELEASE})" ${RELEASE}.gpg ${INRELEASE} | |
858 | done | |
859 | if [ -f "$SECEXPIREBAK" ] && [ -f "$PUBEXPIREBAK" ]; then | |
860 | mv -f $SECEXPIREBAK ${REXKEY}.sec | |
861 | mv -f $PUBEXPIREBAK ${REXKEY}.pub | |
862 | fi | |
863 | msgdone "info" | |
864 | } | |
865 | ||
866 | webserverconfig() { | |
867 | msgtest "Set webserver config option '${1}' to" "$2" | |
868 | local DOWNLOG='rootdir/tmp/download-testfile.log' | |
869 | local STATUS='rootdir/tmp/webserverconfig.status' | |
870 | rm -f "$STATUS" "$DOWNLOG" | |
871 | if downloadfile "http://localhost:8080/_config/set/${1}/${2}" "$STATUS" > "$DOWNLOG"; then | |
872 | msgpass | |
873 | else | |
874 | cat "$DOWNLOG" "$STATUS" | |
875 | msgfail | |
876 | fi | |
877 | testwebserverlaststatuscode '200' | |
878 | } | |
879 | ||
880 | rewritesourceslist() { | |
881 | local APTARCHIVE="file://$(readlink -f "${TMPWORKINGDIRECTORY}/aptarchive")" | |
882 | for LIST in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do | |
883 | sed -i $LIST -e "s#$APTARCHIVE#${1}#" -e "s#http://localhost:8080/#${1}#" -e "s#http://localhost:4433/#${1}#" | |
884 | done | |
885 | } | |
886 | ||
887 | changetowebserver() { | |
888 | if [ "$1" != '--no-rewrite' ]; then | |
889 | rewritesourceslist 'http://localhost:8080/' | |
890 | else | |
891 | shift | |
892 | fi | |
893 | if test -x ${APTWEBSERVERBINDIR}/aptwebserver; then | |
894 | cd aptarchive | |
895 | local LOG="webserver.log" | |
896 | if ! aptwebserver -o aptwebserver::fork=1 "$@" >$LOG 2>&1 ; then | |
897 | cat $LOG | |
898 | false | |
899 | fi | |
900 | local PID="$(cat aptwebserver.pid)" | |
901 | if [ -z "$PID" ]; then | |
902 | msgdie 'Could not fork aptwebserver successfully' | |
903 | fi | |
904 | addtrap "kill $PID;" | |
905 | cd - > /dev/null | |
906 | else | |
907 | msgdie 'You have to build aptwerbserver or install a webserver' | |
908 | fi | |
909 | } | |
910 | ||
911 | changetohttpswebserver() { | |
912 | if ! which stunnel4 >/dev/null; then | |
913 | msgdie 'You need to install stunnel4 for https testcases' | |
914 | fi | |
915 | if [ ! -e "${TMPWORKINGDIRECTORY}/aptarchive/aptwebserver.pid" ]; then | |
916 | changetowebserver --no-rewrite "$@" | |
917 | fi | |
918 | echo "pid = ${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid | |
919 | cert = ${TESTDIRECTORY}/apt.pem | |
920 | output = /dev/null | |
921 | ||
922 | [https] | |
923 | accept = 4433 | |
924 | connect = 8080 | |
925 | " > ${TMPWORKINGDIRECTORY}/stunnel.conf | |
926 | stunnel4 "${TMPWORKINGDIRECTORY}/stunnel.conf" | |
927 | local PID="$(cat ${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid)" | |
928 | addtrap 'prefix' "kill ${PID};" | |
929 | rewritesourceslist 'https://localhost:4433/' | |
930 | } | |
931 | ||
932 | changetocdrom() { | |
933 | mkdir -p rootdir/media/cdrom/.disk | |
934 | local CD="$(readlink -f rootdir/media/cdrom)" | |
935 | echo "acquire::cdrom::mount \"${CD}\"; | |
936 | acquire::cdrom::${CD}/::mount \"mv ${CD}-unmounted ${CD}\"; | |
937 | acquire::cdrom::${CD}/::umount \"mv ${CD} ${CD}-unmounted\"; | |
938 | acquire::cdrom::autodetect 0;" > rootdir/etc/apt/apt.conf.d/00cdrom | |
939 | echo -n "$1" > ${CD}/.disk/info | |
940 | if [ ! -d aptarchive/dists ]; then | |
941 | msgdie 'Flat file archive cdroms can not be created currently' | |
942 | return 1 | |
943 | fi | |
944 | mv aptarchive/dists "$CD" | |
945 | ln -s "$(readlink -f ./incoming)" $CD/pool | |
946 | find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list' -delete | |
947 | # start with an unmounted disk | |
948 | mv "${CD}" "${CD}-unmounted" | |
949 | # we don't want the disk to be modifiable | |
950 | addtrap 'prefix' "chmod -f -R +w $PWD/rootdir/media/cdrom/dists/ $PWD/rootdir/media/cdrom-unmounted/dists/ || true;" | |
951 | chmod -R -w rootdir/media/cdrom-unmounted/dists | |
952 | } | |
953 | ||
954 | downloadfile() { | |
955 | local PROTO="$(echo "$1" | cut -d':' -f 1 )" | |
956 | apthelper -o Acquire::https::CaInfo=${TESTDIR}/apt.pem \ | |
957 | -o Debug::Acquire::${PROTO}=1 \ | |
958 | download-file "$1" "$2" 2>&1 || true | |
959 | # only if the file exists the download was successful | |
960 | if [ -e "$2" ]; then | |
961 | return 0 | |
962 | else | |
963 | return 1 | |
964 | fi | |
965 | } | |
966 | ||
967 | checkdiff() { | |
968 | local DIFFTEXT="$(command diff -u "$@" | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')" | |
969 | if [ -n "$DIFFTEXT" ]; then | |
970 | echo >&2 | |
971 | echo >&2 "$DIFFTEXT" | |
972 | return 1 | |
973 | else | |
974 | return 0 | |
975 | fi | |
976 | } | |
977 | ||
978 | testfileequal() { | |
979 | local FILE="$1" | |
980 | shift | |
981 | msgtest "Test for correctness of file" "$FILE" | |
982 | if [ -z "$*" ]; then | |
983 | echo -n "" | checkdiff $FILE - && msgpass || msgfail | |
984 | else | |
985 | echo "$*" | checkdiff $FILE - && msgpass || msgfail | |
986 | fi | |
987 | } | |
988 | ||
989 | testempty() { | |
990 | msgtest "Test for no output of" "$*" | |
991 | test -z "$($* 2>&1)" && msgpass || msgfail | |
992 | } | |
993 | ||
994 | testequal() { | |
995 | local MSG='Test of equality of' | |
996 | if [ "$1" = '--nomsg' ]; then | |
997 | MSG='' | |
998 | shift | |
999 | fi | |
1000 | ||
1001 | local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequal.comparefile" | |
1002 | echo "$1" > $COMPAREFILE | |
1003 | shift | |
1004 | ||
1005 | if [ -n "$MSG" ]; then | |
1006 | msgtest "$MSG" "$*" | |
1007 | fi | |
1008 | $* 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail | |
1009 | } | |
1010 | ||
1011 | testequalor2() { | |
1012 | local COMPAREFILE1="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile1" | |
1013 | local COMPAREFILE2="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile2" | |
1014 | local COMPAREAGAINST="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.compareagainst" | |
1015 | echo "$1" > $COMPAREFILE1 | |
1016 | echo "$2" > $COMPAREFILE2 | |
1017 | shift 2 | |
1018 | msgtest "Test for equality OR of" "$*" | |
1019 | $* >$COMPAREAGAINST 2>&1 || true | |
1020 | if checkdiff $COMPAREFILE1 $COMPAREAGAINST >/dev/null 2>&1 || \ | |
1021 | checkdiff $COMPAREFILE2 $COMPAREAGAINST >/dev/null 2>&1 | |
1022 | then | |
1023 | msgpass | |
1024 | else | |
1025 | echo -n "\n${CINFO}Diff against OR 1${CNORMAL}" | |
1026 | checkdiff $COMPAREFILE1 $COMPAREAGAINST || true | |
1027 | echo -n "${CINFO}Diff against OR 2${CNORMAL}" | |
1028 | checkdiff $COMPAREFILE2 $COMPAREAGAINST || true | |
1029 | msgfail | |
1030 | fi | |
1031 | } | |
1032 | ||
1033 | testshowvirtual() { | |
1034 | local VIRTUAL="N: Can't select versions from package '$1' as it is purely virtual" | |
1035 | local PACKAGE="$1" | |
1036 | shift | |
1037 | while [ -n "$1" ]; do | |
1038 | VIRTUAL="${VIRTUAL} | |
1039 | N: Can't select versions from package '$1' as it is purely virtual" | |
1040 | PACKAGE="${PACKAGE} $1" | |
1041 | shift | |
1042 | done | |
1043 | msgtest "Test for virtual packages" "apt-cache show $PACKAGE" | |
1044 | VIRTUAL="${VIRTUAL} | |
1045 | N: No packages found" | |
1046 | local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testshowvirtual.comparefile" | |
1047 | local ARCH="$(getarchitecture 'native')" | |
1048 | echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE | |
1049 | aptcache show -q=0 $PACKAGE 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail | |
1050 | } | |
1051 | ||
1052 | testnopackage() { | |
1053 | msgtest "Test for non-existent packages" "apt-cache show $*" | |
1054 | local SHOWPKG="$(aptcache show "$@" 2>&1 | grep '^Package: ')" | |
1055 | if [ -n "$SHOWPKG" ]; then | |
1056 | echo >&2 | |
1057 | echo >&2 "$SHOWPKG" | |
1058 | msgfail | |
1059 | else | |
1060 | msgpass | |
1061 | fi | |
1062 | } | |
1063 | ||
1064 | testdpkginstalled() { | |
1065 | msgtest "Test for correctly installed package(s) with" "dpkg -l $*" | |
1066 | local PKGS="$(dpkg -l "$@" 2>/dev/null | grep '^i' | wc -l)" | |
1067 | if [ "$PKGS" != $# ]; then | |
1068 | echo >&2 $PKGS | |
1069 | dpkg -l "$@" | grep '^[a-z]' >&2 | |
1070 | msgfail | |
1071 | else | |
1072 | msgpass | |
1073 | fi | |
1074 | } | |
1075 | ||
1076 | testdpkgnotinstalled() { | |
1077 | msgtest "Test for correctly not-installed package(s) with" "dpkg -l $*" | |
1078 | local PKGS="$(dpkg -l "$@" 2> /dev/null | grep '^i' | wc -l)" | |
1079 | if [ "$PKGS" != 0 ]; then | |
1080 | echo | |
1081 | dpkg -l "$@" | grep '^[a-z]' >&2 | |
1082 | msgfail | |
1083 | else | |
1084 | msgpass | |
1085 | fi | |
1086 | } | |
1087 | ||
1088 | testmarkedauto() { | |
1089 | local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testmarkedauto.comparefile" | |
1090 | if [ -n "$1" ]; then | |
1091 | msgtest 'Test for correctly marked as auto-installed' "$*" | |
1092 | while [ -n "$1" ]; do echo "$1"; shift; done | sort > $COMPAREFILE | |
1093 | else | |
1094 | msgtest 'Test for correctly marked as auto-installed' 'no package' | |
1095 | echo -n > $COMPAREFILE | |
1096 | fi | |
1097 | aptmark showauto 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail | |
1098 | } | |
1099 | ||
1100 | testsuccess() { | |
1101 | if [ "$1" = '--nomsg' ]; then | |
1102 | shift | |
1103 | else | |
1104 | msgtest 'Test for successful execution of' "$*" | |
1105 | fi | |
1106 | local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output" | |
1107 | if $@ >${OUTPUT} 2>&1; then | |
1108 | msgpass | |
1109 | else | |
1110 | echo >&2 | |
1111 | cat >&2 $OUTPUT | |
1112 | msgfail | |
1113 | fi | |
1114 | } | |
1115 | ||
1116 | testfailure() { | |
1117 | if [ "$1" = '--nomsg' ]; then | |
1118 | shift | |
1119 | else | |
1120 | msgtest 'Test for failure in execution of' "$*" | |
1121 | fi | |
1122 | local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output" | |
1123 | if $@ >${OUTPUT} 2>&1; then | |
1124 | echo >&2 | |
1125 | cat >&2 $OUTPUT | |
1126 | msgfail | |
1127 | else | |
1128 | msgpass | |
1129 | fi | |
1130 | } | |
1131 | ||
1132 | testwebserverlaststatuscode() { | |
1133 | local DOWNLOG='rootdir/tmp/webserverstatus-testfile.log' | |
1134 | local STATUS='rootdir/tmp/webserverstatus-statusfile.log' | |
1135 | rm -f "$DOWNLOG" "$STATUS" | |
1136 | msgtest 'Test last status code from the webserver was' "$1" | |
1137 | downloadfile "http://localhost:8080/_config/find/aptwebserver::last-status-code" "$STATUS" > "$DOWNLOG" | |
1138 | if [ "$(cat "$STATUS")" = "$1" ]; then | |
1139 | msgpass | |
1140 | else | |
1141 | echo >&2 | |
1142 | if [ -n "$2" ]; then | |
1143 | shift | |
1144 | echo >&2 '#### Additionally provided output files contain:' | |
1145 | cat >&2 "$@" | |
1146 | fi | |
1147 | echo >&2 '#### Download log of the status code:' | |
1148 | cat >&2 "$DOWNLOG" | |
1149 | msgfail "Status was $(cat "$STATUS")" | |
1150 | fi | |
1151 | } | |
1152 | ||
1153 | pause() { | |
1154 | echo "STOPPED execution. Press enter to continue" | |
1155 | local IGNORE | |
1156 | read IGNORE | |
1157 | } |